/******************************************************************************/
/*                                                                            */
/*         SAS Program to Convert SAS Export Files to SAS Data Files          */
/*                      TIMSS and PIRLS 2011  User Guide                      */
/*                                                                            */
/******************************************************************************/

OPTIONS NONOTES ;

* Specify the file type ;
* <type> must be edited ;

%LET TYPE = <type> ;

* Specify the path for the sas export files following the format x:\xxx\ ;
* <exppath> must be edited ;

%LET EXPPATH = <exppath> ;

* Specify the path for the SAS data files following the format x:\xxx\ ;
* <datpath> must be edited ;

%LET DATPATH = <datpath> ;

%MACRO DOIT ;

   %LET COUNTRY = AUS AUT AZE TWN HRV CZE FIN GEO DEU HKG
                  HUN IRN IRL ITA LTU MLT MAR NIR NOR OMN
                  PRT POL QAT ROM RUS SAU SGP SVK SVN ESP
                  SWE ARE
                  BWA HND
                  CQU AAD ADU ;

   %LET I = 1 ;
   %DO %WHILE(%LENGTH(%SCAN(&COUNTRY,&I))) ;
      %LET CTRY = %SCAN(&COUNTRY,&i) ;

      PROC CIMPORT FILE = "&EXPPATH&TYPE&CTRY.B1.EXP"
                   DATA = "&DATPATH&TYPE&CTRY.B1" ;
      RUN;

      %LET I = %EVAL(&I + 1) ;
   %END ;

%MEND DOIT ;

%DOIT ;
